#include <windows.h>
#include <commctrl.h>
#include "halloc.h"
#include "divider.h"
#include "binedit.h"
#include "resource.h"

#define BE4(p)			( ((BYTE*)(p))[0] << 24 | ((BYTE*)(p))[1] << 16 | ((BYTE*)(p))[2] << 8 | ((BYTE*)(p))[3] << 0)
#define xisascii(c)		(0x20 <= (c) && (c) <= 0x7E)
#define idivfloor(i, f)	(((i) + (f) - 1) / (f))

struct tagItem{
	BOOL isRoot;
	BOOL isNode;
	BOOL isDetail;	// Is item of detail of ATOM?
	BYTE* data;
	DWORD offset;
	DWORD size;
};

BYTE* atomdef = NULL;

/*************************/
/* Text assist functions */
/*************************/
LPTSTR getLine(LPCTSTR* str)
{
	LPTSTR line;
	LPCTSTR p, q;

	if(str == NULL || *str == NULL || **str == '\0')
		return NULL;

	for(p = q = *str; /*p &&*/ *p && *p != '\r' && *p != '\n'; q = p)
		if(CharNext(p))
			p = CharNext(p);
		else
		{
			p++;
			break;
		}

	if(*p == '\r' && *(p + 1) == '\n')
		p++;

	if(*p == '\r' || *p == '\n')	// increase, but don't in *p==NULL!
		p++;

	/*if(!p)
		;*/

	if((line = halloc(q - *str + 1)) == NULL)
		return NULL;

	// lstrcpy...
	memcpy(line, *str, q - *str);
	line[q - *str] = '\0';

	*str = p;

	return line;
}
/*************************/
/*         END           */
/*************************/




void atomAnalyzer(BYTE* data, DWORD size, HWND hTreeView, HTREEITEM tRootItem)
{
	LPCTSTR ad;

	if(!atomdef)
		return;

	ad = atomdef;

	{
		LPTSTR test;

		for(;;)
		{
		test = getLine(&ad);
		if(!test)
			break;
		//OutputDebugString(test);
		//OutputDebugString("\r\n");
		if(test[0] == '[')
		{
			LPTSTR p, q;

			for(p = test + 1, q = data + 4; *p != '\0' && *p != ']'; p++, q++)
				if(*p != *q)
					break;

			if(*p == '\0' || *p == ']')
			{
				LPTSTR line;
				TV_INSERTSTRUCT ti;

				ti.hParent = tRootItem;
				ti.hInsertAfter = TVI_LAST;
				ti.item.mask = TVIF_TEXT;
				ti.item.pszText = test;

				TreeView_InsertItem(hTreeView, &ti);

				while((line = getLine(&ad)) != NULL && *line && *line != '[')
				{
					// 擪Xy[X

					// #̏

					ti.item.pszText = line;
					TreeView_InsertItem(hTreeView, &ti);
					hfree(line);
				}
			}
		}

		hfree(test);
		}
	}

	return;
}

BOOL atomRecurse(HWND hTreeView, HTREEITEM parent, BYTE* data, DWORD offset, DWORD length)
{
	DWORD ofs = 0;
	BOOL nodeAvailable = FALSE;

	// TODO:.
	if(length == 0)
	{
		return FALSE;
	}

	while(ofs < length)
	{
		DWORD size;
		char atom[5];

		size = BE4(data + offset + ofs);
		memcpy(atom, data + offset + ofs + 4, 4);
		atom[4] = '\0';

		if(	!xisascii(atom[0]) ||
			!xisascii(atom[1]) ||
			!xisascii(atom[2]) ||
			!xisascii(atom[3]) )
			break;

		{
			TV_INSERTSTRUCT tvis;
			TCHAR ts[64];
			struct tagItem* it;
			HTREEITEM titem;

			nodeAvailable = TRUE;

			tvis.hParent = parent;
			tvis.hInsertAfter = TVI_LAST;
			tvis.item.mask = TVIF_TEXT | TVIF_PARAM;

			it = halloc(sizeof(struct tagItem));
			it->isNode = FALSE;
			it->isRoot = FALSE;
			it->isDetail = FALSE;
			it->data = data;
			it->offset = offset + ofs + 8;
			if(size == 0)
			{
				it->size = length - 8 - ofs;
			}else
				it->size = size - 8;
			tvis.item.lParam = (LPARAM)it;

			wsprintf(ts, TEXT("%s (+0x%08X:%u[0x%X])"), atom, offset + ofs, it->size, it->size);
			tvis.item.pszText = ts;

			titem = TreeView_InsertItem(hTreeView, &tvis);

			// atomAnalyzer: TreeViewɉ͂eǉ
			atomAnalyzer(data + offset + ofs, size, hTreeView, titem);

			if(size == 0)
			{
				return FALSE;
			}

			// ChildNodeSearch
			//if(!(GetAsyncKeyState(VK_ESCAPE) & 0x8000))
			if(!atomRecurse(hTreeView, titem, data, offset + ofs + 8, size - 8))
			{
				it->isNode = TRUE;
			}
		}

		ofs += size;
	}

	return nodeAvailable;
}

void openfile(HWND hTreeView, LPCTSTR fname)
{
	HANDLE hf;
	BYTE* data;
	DWORD size;
	DWORD read;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		return;

	TreeView_DeleteAllItems(hTreeView);

	size = GetFileSize(hf, NULL);
	data = halloc(size);
	ReadFile(hf, data, size, &read, NULL);
	// TODO: ErrorCheck
	CloseHandle(hf);

	{
		TV_INSERTSTRUCT tvis;

		tvis.hParent = TVI_ROOT;
		tvis.hInsertAfter = TVI_LAST;
		tvis.item.mask = TVIF_TEXT | TVIF_PARAM;
		tvis.item.pszText = (LPTSTR)fname;
		{
			struct tagItem* it;

			it = halloc(sizeof(struct tagItem));
			it->isRoot = TRUE;
			it->isNode = FALSE;
			it->isDetail = FALSE;
			it->data = data;
			it->offset = 0;
			it->size = size;

			tvis.item.lParam = (LPARAM)it;
		}

		atomRecurse(hTreeView, TreeView_InsertItem(hTreeView, &tvis), data, 0, size);
	}

	return;
}

/*
void appendWindowText(HWND hWnd, LPCTSTR text)
{
	LPTSTR tmp;

	tmp = halloc(SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0) + lstrlen(text) + 1);
	GetWindowText(hWnd, tmp, SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0) + 1);
	lstrcat(tmp, text);
	SetWindowText(hWnd, tmp);

	return;
}
*/

/*
void setDataHex(HWND hEdit, BYTE* data, DWORD offset, DWORD length)
{
	LPTSTR out, os;
	BOOL shift = FALSE;
	UINT startaddr = 0;

	SendMessage(hEdit, BEM_SETDATA, length, (LPARAM)(data + offset));

	os = out = halloc(77 * (2 + idivfloor(length + (offset & 0x0F), 16)) + 1);

	//				  123456789_123456789_123456789_123456789_123456789_123456789_123456789_1234567
	lstrcpy(os, TEXT("        : +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F :   A S C I I    \r\n")),	os += 77;
	lstrcpy(os, TEXT("--------+-------------------------------------------------+----------------\r\n")),	os += 77;

	startaddr = offset;

	while(length)
	{
		TCHAR ts[256];
		LPTSTR s = ts;
		UINT i, l, o;

		wsprintf(s, TEXT("%08X: "), offset - startaddr),	s += 10;

		if(shift)
			for(i = 0; i < (offset & 0x0F); i++)
				lstrcpy(s, TEXT("   ")),	s += 3;
		else
			i = 0;

		for(l = length, o = offset; l && i < 16; i++, l--)
			wsprintf(s, TEXT("%02X "), *(data + o++)),	s += 3;
		for(; i < 16; i++)
			lstrcpy(s, TEXT("   ")),	s += 3;

		lstrcpy(s, TEXT("|")),	s++;

		if(shift)
			for(i = 0; i < (offset & 0x0F); i++)
				lstrcpy(s, TEXT(" ")),	s ++;
		else
			i = 0;
		for(; length && i < 16; i++, length--, offset++)
			if(0x20 <= *(data + offset) && *(data + offset) <= 0x7E)
				wsprintf(s, TEXT("%c"), *(data + offset)),	s++;
			else
				lstrcpy(s, TEXT(".")),	s++;
		lstrcpy(s, TEXT("\r\n"));
		s += 2;

		lstrcpy(os, ts);
		os += s - ts;
	}

	SetWindowText(hEdit, out);

	hfree(out);

	return;
}
*/



LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_CREATE:
		{
			CREATESTRUCT* cs = (void*)lParam;
			HWND div = CreateWindowEx(0, WC_DIVIDER, NULL, WS_CHILD | WS_VISIBLE, 0, 0, 0, 0, hWnd, NULL, GetModuleHandle(NULL), (void*)DIVIDER_HORIZONTAL);

			Divider_SetWindow(div, 0, CreateWindowEx(WS_EX_CLIENTEDGE, WC_TREEVIEW, NULL, WS_CHILD | WS_VISIBLE | TVS_HASBUTTONS | TVS_HASLINES | TVS_LINESATROOT | TVS_SHOWSELALWAYS/* | TVS_FULLROWSELECT*/, 0, 0, 0, 0, div, NULL, GetModuleHandle(NULL), NULL));
			//Divider_SetWindow(div, 1, CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD | WS_VISIBLE | ES_MULTILINE | WS_VSCROLL | ES_AUTOVSCROLL, 0, 0, 0, 0, div, NULL, GetModuleHandle(NULL), NULL));
			Divider_SetWindow(div, 1, CreateWindowEx(WS_EX_CLIENTEDGE, WC_BINEDIT, NULL, WS_CHILD | WS_VISIBLE, 0, 0, 0, 0, div, NULL, GetModuleHandle(NULL), NULL));

			SetWindowLong(hWnd, GWL_USERDATA, (LONG)div);

			{
				LOGFONT lf = {0};

				lf.lfCharSet = DEFAULT_CHARSET;
				lf.lfHeight = 12;
				lstrcpy(lf.lfFaceName, TEXT("lr SVbN"));

				SendMessage(Divider_GetWindow(div, 0), WM_SETFONT, (WPARAM)CreateFontIndirect(&lf), MAKELPARAM(TRUE, 0));
				SendMessage(Divider_GetWindow(div, 1), WM_SETFONT, (WPARAM)CreateFontIndirect(&lf), MAKELPARAM(TRUE, 0));
			}

			if(cs->lpCreateParams)
				openfile(Divider_GetWindow(div, 0), cs->lpCreateParams);
		}
		return 0;
	case WM_SIZE:
		SetWindowPos((HWND)GetWindowLong(hWnd, GWL_USERDATA), NULL, 0, 0, LOWORD(lParam), HIWORD(lParam), SWP_NOZORDER);
		return 0;
	case WM_DROPFILES:
		{
			TCHAR fn[MAX_PATH];

			DragQueryFile((HDROP)wParam, 0, fn, sizeof(fn));
			DragFinish((HDROP)wParam);

			openfile(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 0), fn);
		}
		return 0;
	case WM_NOTIFY:
		{
			NMHDR* nmh = (void*)lParam;

			if(nmh->code == TVN_DELETEITEM)
			{
				NM_TREEVIEW* nmt = (void*)lParam;

				if(nmt->itemOld.lParam)
				{
					struct tagItem* it = (void*)nmt->itemOld.lParam;
					if(it->isRoot)
					{
						hfree(it->data);
						SendMessage(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 1), BEM_SETDATA, 0, 0);
					}
					hfree(it);
				}
			}
			if(nmh->code == TVN_SELCHANGED)
			{
				NM_TREEVIEW* nmt = (void*)lParam;

				if(nmt->itemNew.lParam/* && ((GetAsyncKeyState(VK_SHIFT) & 0x8000) || !((struct tagItem*)nmt->itemNew.lParam)->isRoot)*/)
					/*
					setDataHex(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 1),
						((struct tagItem*)nmt->itemNew.lParam)->data,
						((struct tagItem*)nmt->itemNew.lParam)->offset,
						((struct tagItem*)nmt->itemNew.lParam)->size);
						*/
					SendMessage(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 1), BEM_SETDATA, ((struct tagItem*)nmt->itemNew.lParam)->size, (LPARAM)(((struct tagItem*)nmt->itemNew.lParam)->data + ((struct tagItem*)nmt->itemNew.lParam)->offset));
				else
					//SetWindowText(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 1), NULL);
					SendMessage(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 1), BEM_SETDATA, 0, 0);
			}
			if(nmh->code == TVN_KEYDOWN)
			{
				TV_KEYDOWN* nmk = (void*)lParam;

				if(nmk->wVKey == VK_DELETE)
					TreeView_DeleteAllItems(Divider_GetWindow((HWND)GetWindowLong(hWnd, GWL_USERDATA), 0));
			}
		}
		break;
	case WM_CLOSE:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

HWND initWnd(LPCTSTR cmdline)
{
	WNDCLASSEX wc = {0};

	wc.cbSize = sizeof(wc);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_APPICON));
	wc.lpszClassName = TEXT("MainWndProc");
	wc.lpfnWndProc = MainWndProc;

	if(!RegisterClassEx(&wc))
		return NULL;

	return CreateWindowEx(WS_EX_ACCEPTFILES, wc.lpszClassName, TEXT("atomtree - drop me m4v, 3g2, kind of MPEG4..."), WS_THICKFRAME | WS_CAPTION | WS_SYSMENU | WS_MAXIMIZEBOX | WS_MINIMIZEBOX,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, wc.hInstance, (void*)cmdline);
}

void WinMainCRTStartup(void)
{
	MSG msg;
	HWND hMainWnd;
	LPCTSTR cmdline;

	InitCommonControls();

	if(!dividerInit())
		ExitProcess(1);
	if(!bineditInit())
		ExitProcess(2);

	cmdline = GetCommandLine();
	if(*cmdline == '"')
	{	// "cmdname" params...
		cmdline++;
		while(*cmdline && *cmdline != '"')
			cmdline++;
		if(*cmdline)	// '"'
			cmdline++;
		if(*cmdline)	// ' '
			cmdline++;
	}else
	{	// cmdname params...
		while(*cmdline && *cmdline != ' ')
			cmdline++;
		if(*cmdline)
			cmdline++;
	}
	if(!*cmdline)
		cmdline = NULL;

	{
		HANDLE hf;
		TCHAR atomdeffn[MAX_PATH];

		GetModuleFileName(NULL, atomdeffn, sizeof(atomdeffn));
		{	// CutFileName
			LPTSTR p, lastyen = NULL;

			for(p = atomdeffn; *p; p = CharNext(p))
				if(*p == '\\')
					lastyen = p;

			if(lastyen)
				*(lastyen + 1) = '\0';
		}
		lstrcat(atomdeffn, TEXT("atom.def"));

		if((hf = CreateFile(atomdeffn, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE)
		{
			DWORD read;
			DWORD fsize = GetFileSize(hf, NULL);

			atomdef = halloc(fsize + 1);
			ReadFile(hf, atomdef, fsize, &read, NULL);
			atomdef[fsize] = '\0';

			CloseHandle(hf);
		}
	}

	if(!(hMainWnd = initWnd(cmdline)))
		ExitProcess(3);

	{
		STARTUPINFO si;

		si.cb = sizeof(si);
		GetStartupInfo(&si);
		ShowWindow(hMainWnd, si.wShowWindow);
	}

	while(GetMessage(&msg, NULL, 0, 0))
		DispatchMessage(&msg);

	if(atomdef)
		hfree(atomdef);

	bineditTerminate();
	dividerTerminate();

	ExitProcess(msg.wParam);
}
